CF1004F Sonya and Bitwise OR
Sonya and Bitwise OR
题面翻译
有一个长度为 \(n\) 的数组 \(a_{1 \sim n}\) ,有 \(m\) 次操作,操作分两类:
- 将 \(a_i\) 修改成 \(y\) ;
- 给定 \(l\) 和 \(r\) ,询问有多少个区间 \([L, R]\) 满足 \(l \le L \le R \le r\) 且 \(a_{L \sim R}\) 按位或和至少为 \(x\) 。(即: \(a_L \text{ or } a_{L + 1} \text{ or } \cdots \text{ or } a_R \ge x\) )
其中 \(x\) 是一开始给定的一个整数。
\(1 \le n, m \le 10^5\) ; \(0 \le a_i, x, y < 2^{20}\) 。
Translated by @OrangeLee
题目描述
Sonya has an array $ a_1, a_2, \ldots, a_n $ consisting of $ n $ integers and also one non-negative integer $ x $ . She has to perform $ m $ queries of two types:
- $ 1 $ $ i $ $ y $ : replace $ i $ -th element by value $ y $ , i.e. to perform an operation $ a_{i} $ := $ y $ ;
- $ 2 $ $ l $ $ r $ : find the number of pairs ( $ L $ , $ R $ ) that $ l\leq L\leq R\leq r $ and bitwise OR of all integers in the range $ [L, R] $ is at least $ x $ (note that $ x $ is a constant for all queries).
Can you help Sonya perform all her queries?
Bitwise OR is a binary operation on a pair of non-negative integers. To calculate the bitwise OR of two numbers, you need to write both numbers in binary notation. The result is a number, in binary, which contains a one in each digit if there is a one in the binary notation of at least one of the two numbers. For example, $ 10 $ OR $ 19 $ = $ 1010_2 $ OR $ 10011_2 $ = $ 11011_2 $ = $ 27 $ .
输入格式
The first line contains three integers $ n $ , $ m $ , and $ x $ ( $ 1\leq n, m\leq 10^5 $ , $ 0\leq x<2^{20} $ ) — the number of numbers, the number of queries, and the constant for all queries.
The second line contains $ n $ integers $ a_1, a_2, \ldots, a_n $ ( $ 0\leq a_i<2^{20} $ ) — numbers of the array.
The following $ m $ lines each describe an query. A line has one of the following formats:
- $ 1 $ $ i $ $ y $ ( $ 1\leq i\leq n $ , $ 0\leq y<2^{20} $ ), meaning that you have to replace $ a_{i} $ by $ y $ ;
- $ 2 $ $ l $ $ r $ ( $ 1\leq l\leq r\leq n $ ), meaning that you have to find the number of subarrays on the segment from $ l $ to $ r $ that the bitwise OR of all numbers there is at least $ x $ .
输出格式
For each query of type 2, print the number of subarrays such that the bitwise OR of all the numbers in the range is at least $ x $ .
样例 #1
样例输入 #1
4 8 7
0 3 6 1
2 1 4
2 3 4
1 1 7
2 1 4
2 1 3
2 1 1
1 3 0
2 1 4
样例输出 #1
5
1
7
4
1
4
样例 #2
样例输入 #2
5 5 7
6 0 3 15 2
2 1 5
1 4 4
2 1 5
2 3 5
2 1 4
样例输出 #2
9
7
2
4
提示
In the first example, there are an array [ $ 0 $ , $ 3 $ , $ 6 $ , $ 1 $ ] and queries:
- on the segment [ $ 1\ldots4 $ ], you can choose pairs ( $ 1 $ , $ 3 $ ), ( $ 1 $ , $ 4 $ ), ( $ 2 $ , $ 3 $ ), ( $ 2 $ , $ 4 $ ), and ( $ 3 $ , $ 4 $ );
- on the segment [ $ 3\ldots4 $ ], you can choose pair ( $ 3 $ , $ 4 $ );
- the first number is being replacing by $ 7 $ , after this operation, the array will consist of [ $ 7 $ , $ 3 $ , $ 6 $ , $ 1 $ ];
- on the segment [ $ 1\ldots4 $ ], you can choose pairs ( $ 1 $ , $ 1 $ ), ( $ 1 $ , $ 2 $ ), ( $ 1 $ , $ 3 $ ), ( $ 1 $ , $ 4 $ ), ( $ 2 $ , $ 3 $ ), ( $ 2 $ , $ 4 $ ), and ( $ 3 $ , $ 4 $ );
- on the segment [ $ 1\ldots3 $ ], you can choose pairs ( $ 1 $ , $ 1 $ ), ( $ 1 $ , $ 2 $ ), ( $ 1 $ , $ 3 $ ), and ( $ 2 $ , $ 3 $ );
- on the segment [ $ 1\ldots1 $ ], you can choose pair ( $ 1 $ , $ 1 $ );
- the third number is being replacing by $ 0 $ , after this operation, the array will consist of [ $ 7 $ , $ 3 $ , $ 0 $ , $ 1 $ ];
- on the segment [ $ 1\ldots4 $ ], you can choose pairs ( $ 1 $ , $ 1 $ ), ( $ 1 $ , $ 2 $ ), ( $ 1 $ , $ 3 $ ), and ( $ 1 $ , $ 4 $ ).
In the second example, there are an array [ $ 6 $ , $ 0 $ , $ 3 $ , $ 15 $ , $ 2 $ ] are queries:
- on the segment [ $ 1\ldots5 $ ], you can choose pairs ( $ 1 $ , $ 3 $ ), ( $ 1 $ , $ 4 $ ), ( $ 1 $ , $ 5 $ ), ( $ 2 $ , $ 4 $ ), ( $ 2 $ , $ 5 $ ), ( $ 3 $ , $ 4 $ ), ( $ 3 $ , $ 5 $ ), ( $ 4 $ , $ 4 $ ), and ( $ 4 $ , $ 5 $ );
- the fourth number is being replacing by $ 4 $ , after this operation, the array will consist of [ $ 6 $ , $ 0 $ , $ 3 $ , $ 4 $ , $ 2 $ ];
- on the segment [ $ 1\ldots5 $ ], you can choose pairs ( $ 1 $ , $ 3 $ ), ( $ 1 $ , $ 4 $ ), ( $ 1 $ , $ 5 $ ), ( $ 2 $ , $ 4 $ ), ( $ 2 $ , $ 5 $ ), ( $ 3 $ , $ 4 $ ), and ( $ 3 $ , $ 5 $ );
- on the segment [ $ 3\ldots5 $ ], you can choose pairs ( $ 3 $ , $ 4 $ ) and ( $ 3 $ , $ 5 $ );
- on the segment [ $ 1\ldots4 $ ], you can choose pairs ( $ 1 $ , $ 3 $ ), ( $ 1 $ , $ 4 $ ), ( $ 2 $ , $ 4 $ ), and ( $ 3 $ , $ 4 $ ).
Solution
今天测试的 T4 ,赛时只做出来了 \(\mathcal O(mn\log n)\) 的做法,所以发现是 CF 原题后就赶快来写正解了。
先考虑暴力该如何做。显然暴力思路很简单,直接枚举子区间的左端点和右端点即可,这样的时间复杂度是 \(\mathcal O(mn^2)\) 这一级别的。
然后来考虑如何优化。观察题目要求的运算,稍微想一下就可以知道当子区间的左端点固定时,区间或和是随着右端点右移而变大的,这启发我们用尺取法/双指针法来做这道题。因为当左端点右移的时候并不能很方便的得出新的区间或和,所以选择线段树来维护区间或和。这一方法的时间复杂度是 \(\mathcal O(mn\log n)\) 的。
难道优化就到此为止了吗?并不是。还是假设确定子区间左端点,那么当我们右移右端点的时候,每一次改变区间或和的时候都至少会对答案的二进制改变一位,所以当左端点固定的时候,不同的区间或和最多只有 \(\log a_i\) 个。所以这一特点启发我们在线段树上维护不同的区间前缀或和和后缀或和的开头位置以及对应的区间或和,同时维护当前线段树区间的答案。在上传的时候直接暴力维护这三个值即可。那么现在的问题就变成了如何利用这些值来求答案。在这里只需要讨论区间跨过了线段树区间中点这一情况,如果不是这种情况都可以递归进子树转化成为这一问题。
如果询问区间跨过了线段树区间中点,那么这个区间的答案就应该是左右子树的答案之和加上左端点在左子树、右端点在右子树的情况数,因为维护好了区间前后缀或和,所以直接利用这些东西进行尺取即可,具体看代码分析。
在代码实现的过程中有一些需要注意的点:
vector
的size()
返回的是一个unsigned
值,需要强制转为int
类才可以使用,否则做减法运算在答案应该是 \(-1\) 时会出现问题。|
或运算的优先级是在逻辑运算符之后的,所以或运算后跟逻辑运算符的时候一定记得打括号!!!(我因为这个原因无端调了 \(2.5\) 小时的代码)
Code
#include<bits/stdc++.h>
#define mem(a,b) memset(a,b,sizeof a)
#define int long long
#define MP make_pair
#define F first
#define S second
using namespace std;
template<typename T> void read(T &k)
{
k=0;T flag=1;char b=getchar();
while (!isdigit(b)) {flag=(b=='-')?-1:1;b=getchar();}
while (isdigit(b)) {k=k*10+b-48;b=getchar();}
k*=flag;
}
const int _SIZE=1e5;
int n,m,x,a[_SIZE+5];
#define LC (k<<1)
#define RC ((k<<1)|1)
int ans[(_SIZE<<2)+5];//记录线段树区间答案
vector<pair<int,int> >up[(_SIZE<<2)+5],down[(_SIZE<<2)+5];//up表示前缀,down表示后缀,first表示位置,second表示值
void pushup(int k,int l,int r)
{
ans[k]=ans[LC]+ans[RC];//先继承左右子树答案
for (int i=0,j=down[LC].size();i<up[RC].size();i++)//对左右子树进行尺取,i在右子树,j在左子树
{
int tail=((i<=(int)up[RC].size()-(int)2) ? up[RC][i+1].F : r+1);//计算尺取的上界
while (j>0 && (down[LC][j-1].S|up[RC][i].S)>=x) j--;//将j代表的位置向后移(因为down是后缀所以位置是从大到小放进去的)
if (j!=down[LC].size()) ans[k]+=(down[LC][j].F-l+1)*(tail-up[RC][i].F);//如果存在j满足条件则更新答案,前半段长度为j对应的位置到下界的数字总数,后半段则是i对应的位置到上界的数字总数
}
up[k]=up[LC];//先继承
for (int i=0;i<up[RC].size();i++)
if (up[k].back().S != (up[RC][i].S|up[k].back().S)) //如果可以得到新的或值
up[k].push_back(MP(up[RC][i].F,up[RC][i].S|up[k].back().S));//将这个新的区间或值加入
down[k]=down[RC];//与up的更新基本相似
for (int i=0;i<down[LC].size();i++)
if (down[k].back().S != (down[LC][i].S|down[k].back().S))
down[k].push_back(MP(down[LC][i].F,down[LC][i].S|down[k].back().S));
}
void build(int k,int l,int r)//建树
{
if (l==r)
{
ans[k]=(a[l]>=x);
up[k].push_back(MP(l,a[l]));//建树的时候直接插入即可
down[k].push_back(MP(l,a[l]));
return;
}
int mid=l+r>>1;
build(LC,l,mid);
build(RC,mid+1,r);
pushup(k,l,r);
}
void update(int k,int l,int r,int pos,int v)
{
if (l==r && l==pos)
{
ans[k]=(v>=x);
up[k][0]=MP(l,v);//建树的时候已经保证有[k][0]了,所以更新[k][0]即可
down[k][0]=MP(l,v);
return;
}
if (l>pos || r<pos) return;
int mid=l+r>>1;
update(LC,l,mid,pos,v);
update(RC,mid+1,r,pos,v);
pushup(k,l,r);
}
int query(int k,int l,int r,int a,int b)
{
if (l==a && r==b) return ans[k];
int mid=l+r>>1;
if (b<=mid) return query(LC,l,mid,a,b);//在左子树,直接递归入左子树
else if (a>mid) return query(RC,mid+1,r,a,b);//与左子树同理
else
{
int res=query(LC,l,mid,a,mid)+query(RC,mid+1,r,mid+1,b);//先分别统计左右子树再统计跨越中点的答案
int j=(int)down[LC].size()-(int)1;
while (down[LC][j].F<a) j--;//先找到j的上界
for (int i=0;i<up[RC].size() && up[RC][i].F<=b;i++)//尺取,与上传相似
{
int tail=(i<=(int)up[RC].size()-(int)2)?up[RC][i+1].F:r+1;
tail=min(tail,b+1);//上界应该保证在询问区间内
if ((down[LC][j].S|up[RC][i].S)<x) continue;
while (j>0 && (down[LC][j-1].S|up[RC][i].S)>=x) j--;
res+=(down[LC][j].F-a+1)*(tail-up[RC][i].F);
}
return res;
}
}
signed main()
{
read(n),read(m),read(x);
for (int i=1;i<=n;i++) read(a[i]);
build(1,1,n);
//return 0;
for (int i=1;i<=m;i++)
{
int op,l,r;
read(op),read(l),read(r);
if (op==1) update(1,1,n,l,r);
else printf("%lld\n",query(1,1,n,l,r));
}
return 0;
}